## ardour 8.6.0+ds

=== wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import subprocess
import sys
import platform as PLATFORM
from waflib.Build import BuildContext
import waflib.Utils as Utils

# Fixup OSX 10.5/10.6 builds
# prefer gcc, g++ 4.x over ancient clang-1.5
from waflib.Tools.compiler_c import c_compiler
from waflib.Tools.compiler_cxx import cxx_compiler
c_compiler['darwin'] = ['gcc', 'clang' ]
cxx_compiler['darwin'] = ['g++', 'clang++' ]

class i18n(BuildContext):
    cmd = 'i18n'
    fun = 'i18n'

class i18n_pot(BuildContext):
    cmd = 'i18n_pot'
    fun = 'i18n_pot'

class i18n_po(BuildContext):
    cmd = 'i18n_po'
    fun = 'i18n_po'

class i18n_mo(BuildContext):
    cmd = 'i18n_mo'
    fun = 'i18n_mo'

compiler_flags_dictionaries= {
    'gcc' : {
        # Flags required when building a debug build
        'debuggable' : [ '-g' ],
        # Flags required for the linker (if any) when building a debug build
        'linker-debuggable' : '',
        # Flags required when building a non-debug optimized build
        'nondebuggable' : '-DNDEBUG',
        # Flags required to enable profiling at runtime with optimized builds
        'profile' : [ '-fno-omit-frame-pointer' ],
        # Flags required to enable gprofile profiling
        'gprofile' : '-pg',
        # Flags required to disable warnings about unused arguments to function calls
        'silence-unused-arguments' : '',
        # Flags required to use SSE unit for general math
        'sse' : '-msse',
        # Flags required to use SSE unit for floating point math
        'fpmath-sse' : '-mfpmath=sse',
        # Flags required to use _xgetbv with mingw+gcc > 8.2
        'xsaveintrin' : '-mxsave',
        # Flags required to use XMM Intrinsics
        'xmmintrinsics' : '-DUSE_XMMINTRIN',
        # Flags to use posix pipes between compiler stages
        'pipe' : '-pipe',
        # Flags for maximally optimized build
        'full-optimization' : [ '-O3', '-fomit-frame-pointer', '-ffast-math', '-fstrength-reduce' ],
        # Flag to ensure that compiler error output includes column/line numbers
        'show-column' : '-fshow-column',
        # Flags required to build for x86 only (OS X feature)
        'generic-x86' : '',
        # Flags required to build for PowerPC only (OS X feature)
        'generic-ppc' : '',
        # Flags required to build for PowerPC only (OS X feature)
        'generic-arm64' : '',
        # All flags required to get basic warnings to be generated by the compiler
        'basic-warnings' : [ '-Wall', '-Wpointer-arith', '-Wcast-qual', '-Wcast-align', '-Wno-unused-parameter' ],
        # Any additional flags for warnings that are specific to C (not C++)
        'extra-c-warnings' : [ '-Wstrict-prototypes', '-Wmissing-prototypes' ],
        # Any additional flags for warnings that are specific to C++ (not C)
        'extra-cxx-warnings' : [ '-Woverloaded-virtual', '-Wno-unused-local-typedefs' ],
        # Flags used for "strict" compilation, C and C++ (i.e. compiler will warn about language issues)
        'strict' : ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings', '-Wunsafe-loop-optimizations', '-Wlogical-op' ],
        # Flags used for "strict" compilation, C only (i.e. compiler will warn about language issues)
        'c-strict' : ['-std=c99', '-pedantic', '-Wshadow'],
        # Flags used for "strict" compilation, C++ only (i.e. compiler will warn about language issues)
        'cxx-strict' : [ '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ],
        # Flags required for whatever consider the strictest possible compilation
        'ultra-strict' : ['-Wredundant-decls', '-Wstrict-prototypes', '-Wmissing-prototypes'],
        # Flag to turn on C99 compliance by itself
        'c99': '-std=c99',
        # Flag to enable AT&T assembler syntax
        'attasm': '-masm=att',
        # Flags to make AVX instructions/intrinsics available
        'avx': '-mavx',
        # Flags to make AVX512F instructions/intrinsics available
        'avx512f': '-mavx512f',
        # Flags to make FMA instructions/intrinsics available
        'fma': '-mfma',
        # Flags to make ARM/NEON instructions/intrinsics available
        'neon': '-mfpu=neon',
        # Flags to generate position independent code, when needed to build a shared object
        'pic': '-fPIC',
        # Flags required to compile C code with anonymous unions (only part of C11)
        'c-anonymous-union': '-fms-extensions',
    },
    'msvc' : {
        'debuggable' : ['/DDEBUG', '/Od', '/Zi', '/MDd', '/Gd', '/EHsc'],
        'linker-debuggable' : ['/DEBUG', '/INCREMENTAL' ],
        'nondebuggable' : ['/DNDEBUG', '/Ob1', '/MD', '/Gd', '/EHsc'],
        'profile' : '/Oy-',
        'silence-unused-arguments' : '',
        'sse' : '',
        'xsaveintrin' : '',
        'fpmath-sse' : '',
        'xmmintrinsics' : '',
        'pipe' : '',
        'full-optimization' : '/O2',
        'no-frame-pointer' : '',
        'fast-math' : '',
        'strength-reduce' : '',
        'show-column' : '',
        'generic-x86' : '',
        'generic-ppc' : '',
        'generic-arm64' : '',
        'basic-warnings' : '',
        'extra-c-warnings' : '',
        'extra-cxx-warnings' : '',
        'ultra-strict' : '',
        'c-strict' : '',
        'cxx-strict' : '',
        'strict' : '',
        'c99': '/TP',
        'attasm': '',
        'avx': '',
        'neon': '',
        'pic': '',
        'c-anonymous-union': '',
    },
}

# Copy, edit and insert variants on gcc dict for gcc-darwin and clang

gcc_darwin_dict = compiler_flags_dictionaries['gcc'].copy()
gcc_darwin_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual' ]
gcc_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual' ]
gcc_darwin_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
gcc_darwin_dict['generic-x86'] = [ '-arch', 'i386' ]
gcc_darwin_dict['generic-ppc'] = [ '-arch', 'ppc' ]
gcc_darwin_dict['generic-arm64'] = [ '-arch', 'arm64' ]
compiler_flags_dictionaries['gcc-darwin'] = gcc_darwin_dict

clang_dict = compiler_flags_dictionaries['gcc'].copy()
clang_dict['sse'] = ''
clang_dict['fpmath-sse'] = ''
clang_dict['xsaveintrin'] = ''
clang_dict['xmmintrinsics'] = ''
clang_dict['silence-unused-arguments'] = '-Qunused-arguments'
clang_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual', '-Wno-mismatched-tags', '-Wno-cast-align', '-Wno-unused-local-typedefs', '-Wunneeded-internal-declaration' ]
clang_dict['basic-warnings'] = [ '-Wall', '-Wpointer-arith', '-Wcast-qual', '-Wcast-align', '-Wno-unused-parameter', '-Wno-deprecated-declarations', '-Wno-deprecated-copy-with-user-provided-copy' ]
clang_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ]
clang_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
clang_dict['generic-x86'] = [ '-arch', 'i386' ]
clang_dict['generic-arm64'] = [ '-arch', 'arm64' ]
clang_dict['full-optimization'] = [ '-O3', '-fomit-frame-pointer', '-ffast-math', ]
compiler_flags_dictionaries['clang'] = clang_dict

clang_darwin_dict = compiler_flags_dictionaries['clang'].copy()
clang_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', ]
clang_darwin_dict['full-optimization'] = [ '-O3', '-ffast-math']
compiler_flags_dictionaries['clang-darwin'] = clang_darwin_dict

# Version stuff

def fetch_git_revision_date ():
    cmd = ["git", "describe", "HEAD"]
    output = subprocess.Popen(cmd, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    rev = re.sub(r"^[A-Za-z0-9]*\+", "", output[0].decode('utf-8'))

    cmd = ["git", "log", "-1", "--pretty=format:%ci", "HEAD"]
    output = subprocess.Popen(cmd, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    date = output[0].decode('utf-8').split(None, 2)[0]

    return rev, date

def fetch_tarball_revision_date():
    if not os.path.exists ('libs/ardour/revision.cc'):
        print ('This tarball was not created correctly - it is missing libs/ardour/revision.cc')
        sys.exit (1)
    with open('libs/ardour/revision.cc', 'rb') as f:
        content = f.readlines()
        remove_punctuation_map = dict((ord(char), None) for char in '";')

        raw_line_tokens = content[1].decode('utf-8').strip().split(' ')
        rev = raw_line_tokens[7].translate(remove_punctuation_map)
        date = raw_line_tokens[12].translate(remove_punctuation_map)

        return rev, date

def set_version (from_file = False):
    def sanitize(s):
        # round-trip to remove anything in the string that is not encodable in
        # ASCII, yet still keep a real (utf8-encoded internally) string.
        s = s.encode ('ascii', 'ignore').decode ("utf-8")
        # In Python3, bytes is the class of binary content and encode() returns
        # bytes to transform a string according to a text encoding; str is the
        # class of normal strings (utf8-encoded internally) and decode() returns
        # that type.
        # Python 2 did not initially cater for encoding problems and can use str
        # for both binary content and for (decoded) strings. The Unicode type was
        # added to correspond to Python 3 str, and the Python 2 str type should
        # only correspond to bytes. Alas, almost everything in the Python 2
        # ecosystem has been written with str in mind and doesn't handle Unicode
        # objects correctly. If Python 2 is in use, s will be a Unicode object and
        # to avoid strange problems later we convert back to str, but in utf-8
        # nonetheless.
        if not isinstance(s, str):
            s = s.encode("utf-8")
        return s

    global MAJOR
    global MINOR
    global MICRO
    global VERSION
    global PROGRAM_VERSION
    global rev_date

    if not from_file and os.path.isdir (os.path.join(os.getcwd(), '.git')):
        rev, rev_date = fetch_git_revision_date()
    else:
        rev, rev_date = fetch_tarball_revision_date()
    rev_date = sanitize(rev_date)

    #
    # rev is now of the form MAJOR.MINOR[-rcX]-rev-commit
    # or, if right at the same rev as a release, MAJOR.MINOR[-rcX]
    #

    parts = sanitize(rev).split ('.', 1)
    MAJOR = parts[0]
    other = parts[1].split('-', 1)
    MINOR = other[0]
    if len(other) > 1:
        MICRO = other[1].rsplit('-',1)[0].replace('-','.')
    else:
        MICRO = '0'

    VERSION = MAJOR + '.' + MINOR + '.' + MICRO
    PROGRAM_VERSION = MAJOR

def fetch_gcc_version (CC):
    cmd = "%s --version" % CC
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    o = output[0].decode('utf-8')
    version = o.split(' ')[2].split('.')
    return version

def create_stored_revision():
    set_version ()
    rev = ""
    if os.path.exists('.git'):
        rev, rev_date = fetch_git_revision_date()
        print("Git version: " + rev + "\n")
    elif os.path.exists('libs/ardour/revision.cc'):
        print("Using packaged revision")
        return
    else:
        print("Missing libs/ardour/revision.cc.  Blame the packager.")
        sys.exit(-1)

    try:
        #
        # if you change the format of this, be sure to fix fetch_tarball_revision_date()
        # above so that  it still works.
        #
        text =  '#include "ardour/revision.h"\n'
        text += (
            'namespace ARDOUR { const char* revision = \"%s\"; '
            'const char* date = \"%s\"; }\n'
        ) % (rev, rev_date)
        print('Writing revision info to libs/ardour/revision.cc using ' + rev + ', ' + rev_date)
        o = open('libs/ardour/revision.cc', 'w')
        o.write(text)
        o.close()
    except IOError:
        print('Could not open libs/ardour/revision.cc for writing\n')
        sys.exit(-1)

def get_depstack_rev(depstack_root):
    try:

=== libs/aaf/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
LIBAAF_VERSION = '0.0.0'
LIBAAF_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'libaaf'
VERSION = LIBAAF_VERSION
I18N_PACKAGE = 'libaaf'

# Mandatory variables
top = '.'
out = 'build'

libaaf_sources = [
	'AAFClass.c',
	'AAFCore.c',
	'AAFDump.c',
	'AAFIEssenceFile.c',
	'AAFIface.c',
	'AAFIParser.c',
	'AAFToText.c',
	'CFBDump.c',
	'LibCFB.c',
	'ProTools.c',
	'MediaComposer.c',
	'Resolve.c',
	'RIFFParser.c',
	'URIParser.c',
	'utils.c',
	'log.c',
]

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    if False and conf.is_defined('USE_EXTERNAL_LIBS'):
        autowaf.check_pkg(conf, 'libaaf', uselib_store='LIBAAF', mandatory=True, atleast_version='0.6.0')

def build(bld):
    if False and bld.is_defined('USE_EXTERNAL_LIBS'):
        return

    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cshlib', source=libaaf_sources)
        obj.defines = [ 'LIBAAF_DLL_EXPORTS=1' ]
    else:
        obj              = bld.stlib(features = 'c cshlib', source=libaaf_sources)
        obj.cflags       = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.defines      = []

    obj.export_includes  = ['.']
    obj.includes         = ['.']
    obj.name             = 'libaaf'
    obj.target           = 'aaf'
    #obj.uselib          = 'GLIB'
    obj.vnum             = LIBAAF_LIB_VERSION
    obj.install_path     = bld.env['LIBDIR']
    obj.defines         += [ 'PACKAGE="' + I18N_PACKAGE + '"' ]

def shutdown():
    autowaf.shutdown()

=== libs/tk/ytk/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os
import sys

# Version of this package (even if built as a child)
MAJOR = '2'
MINOR = '24'
MICRO = '23'
LIBYDK_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

I18N_PACKAGE = 'libytk'

libytk_sources = [
    'fnmatch.c',
    'gtkaboutdialog.c',
    'gtkaccelgroup.c',
    'gtkaccellabel.c',
    'gtkaccelmap.c',
    'gtkaccessible.c',
    'gtkaction.c',
    'gtkactiongroup.c',
    'gtkactivatable.c',
    'gtkadjustment.c',
    'gtkaliasdef.c',
    'gtkalignment.c',
    'gtkarrow.c',
    'gtkaspectframe.c',
    'gtkassistant.c',
    'gtkbbox.c',
    'gtkbin.c',
    'gtkbindings.c',
    'gtkbox.c',
    'gtkbuildable.c',
    'gtkbuilder.c',
    'gtkbuilderparser.c',
    'gtkbutton.c',
    'gtkcelleditable.c',
    'gtkcelllayout.c',
    'gtkcellrenderer.c',
    'gtkcellrendereraccel.c',
    'gtkcellrenderercombo.c',
    'gtkcellrendererpixbuf.c',
    'gtkcellrendererprogress.c',
    'gtkcellrendererspin.c',
    'gtkcellrendererspinner.c',
    'gtkcellrenderertext.c',
    'gtkcellrenderertoggle.c',
    'gtkcellview.c',
    'gtkcheckbutton.c',
    'gtkcheckmenuitem.c',
    'gtkcolorbutton.c',
    'gtkcolorsel.c',
    'gtkcolorseldialog.c',
    'gtkcombobox.c',
    'gtkcomboboxentry.c',
    'gtkcomboboxtext.c',
    'gtkcontainer.c',
    'gtkdialog.c',
    'gtkdrawingarea.c',
    'gtkeditable.c',
    'gtkentry.c',
    'gtkentrybuffer.c',
    'gtkentrycompletion.c',
    'gtkeventbox.c',
    'gtkexpander.c',
    'gtkfilechooser.c',
    'gtkfilechooserbutton.c',
    'gtkfilechooserdefault.c',
    'gtkfilechooserdialog.c',
    'gtkfilechooserembed.c',
    'gtkfilechooserentry.c',
    'gtkfilechoosersettings.c',
    'gtkfilechooserutils.c',
    'gtkfilechooserwidget.c',
    'gtkfilefilter.c',
    'gtkfilesystem.c',
    'gtkfilesystemmodel.c',
    'gtkfixed.c',
    'gtkfontbutton.c',
    'gtkfontsel.c',
    'gtkframe.c',
    'gtkgc.c',
    'gtkhandlebox.c',
    'gtkhbbox.c',
    'gtkhbox.c',
    'gtkhpaned.c',
    'gtkhruler.c',
    'gtkhscale.c',
    'gtkhscrollbar.c',
    'gtkhseparator.c',
    'gtkhsv.c',
    'gtkiconcache.c',
    'gtkiconcachevalidator.c',
    'gtkiconfactory.c',
    'gtkicontheme.c',
    'gtkiconview.c',
    'gtkimage.c',
    'gtkimagemenuitem.c',
    'gtkimcontext.c',
    'gtkimcontextsimple.c',
    'gtkimmodule.c',
    'gtkimmulticontext.c',
    'gtkinfobar.c',
    'gtkinvisible.c',
    'gtkitem.c',
    'gtkkeyhash.c',
    'gtklabel.c',
    'gtklayout.c',
    'gtklinkbutton.c',
    'gtkliststore.c',
    'gtkmain.c',
    'gtkmarshal.c',
    'gtkmarshalers.c',
    'gtkmenu.c',
    'gtkmenubar.c',
    'gtkmenuitem.c',
    'gtkmenushell.c',
    'gtkmenutoolbutton.c',
    'gtkmessagedialog.c',
    'gtkmisc.c',
    'gtkmnemonichash.c',
    'gtkmodules.c',
    'gtkmountoperation.c',
    'gtknotebook.c',
    'gtkobject.c',
    'gtkoffscreenwindow.c',
    'gtkoptionmenu.c',
    'gtkorientable.c',
    'gtkpaned.c',
    'gtkpango.c',
    'gtkpathbar.c',
    'gtkplug.c',
    'gtkprogress.c',
    'gtkprogressbar.c',
    'gtkquery.c',
    'gtkradioaction.c',
    'gtkradiobutton.c',
    'gtkradiomenuitem.c',
    'gtkradiotoolbutton.c',
    'gtkrange.c',
    'gtkrbtree.c',
    'gtkrc.c',
    'gtkrecentaction.c',
    'gtkrecentchooser.c',
    'gtkrecentchooserdefault.c',
    'gtkrecentchooserdialog.c',
    'gtkrecentchoosermenu.c',
    'gtkrecentchooserutils.c',
    'gtkrecentchooserwidget.c',
    'gtkrecentfilter.c',
    'gtkrecentmanager.c',
    'gtkruler.c',
    'gtkscale.c',
    'gtkscalebutton.c',
    'gtkscrollbar.c',
    'gtkscrolledwindow.c',
    'gtksearchengine.c',
    'gtksearchenginesimple.c',
    'gtkselection.c',
    'gtkseparator.c',
    'gtkseparatormenuitem.c',
    'gtkseparatortoolitem.c',
    'gtksettings.c',
    'gtkshow.c',
    'gtksizegroup.c',
    'gtksocket.c',
    'gtkspinbutton.c',
    'gtkspinner.c',
    'gtkstatusbar.c',
    'gtkstock.c',
    'gtkstyle.c',
    'gtktable.c',
    'gtktearoffmenuitem.c',
    'gtktextbtree.c',
    'gtktextbuffer.c',
    'gtktextbufferrichtext.c',
    'gtktextbufferserialize.c',
    'gtktextchild.c',
    'gtktextdisplay.c',
    'gtktextiter.c',
    'gtktextlayout.c',
    'gtktextmark.c',
    'gtktextsegment.c',
    'gtktexttag.c',
    'gtktexttagtable.c',
    'gtktexttypes.c',
    'gtktextutil.c',
    'gtktextview.c',
    'gtkthemes.c',
    'gtktoggleaction.c',
    'gtktogglebutton.c',
    'gtktoggletoolbutton.c',
    'gtktoolbar.c',
    'gtktoolbutton.c',
    'gtktoolitem.c',
    'gtktoolitemgroup.c',
    'gtktoolpalette.c',
    'gtktoolshell.c',
    'gtktooltip.c',
    'gtktooltips.c',
    'gtktreedatalist.c',
    'gtktreednd.c',
    'gtktreemodel.c',
    'gtktreemodelfilter.c',
    'gtktreemodelsort.c',
    'gtktreeselection.c',
    'gtktreesortable.c',
    'gtktreestore.c',
    'gtktreeview.c',
    'gtktreeviewcolumn.c',
    'gtktypebuiltins.c',
    'gtktypeutils.c',
    'gtkuimanager.c',
    'gtkvbbox.c',
    'gtkvbox.c',
    'gtkviewport.c',
    'gtkvpaned.c',
    'gtkvruler.c',
    'gtkvscale.c',
    'gtkvscrollbar.c',
    'gtkvseparator.c',
    'gtkwidget.c',
    'gtkwindow-decorate.c',
    'gtkwindow.c',
]

libytk_x11_sources = [
    'gtkclipboard.c',
    'gtkdnd.c',
    'gtkmountoperation-x11.c',
    'gtkplug-x11.c',
    'gtksocket-x11.c',
    'gtkxembed.c',
]

libytk_quartz_sources = [
    'gtkclipboard-quartz.c',
    'gtkdnd-quartz.c',
    'gtkmountoperation-stub.c',
    'gtkplug-stub.c',
    'gtkquartz.c',
    'gtksearchenginequartz.c',
    'gtksocket-stub.c',
]

libytk_win32_sources = [
    'gtkclipboard.c',
    'gtkdnd.c',
    'gtkplug-win32.c',
    'gtksocket-win32.c',
    'gtkwin32embed.c',
    'gtkwin32embedwidget.c',
    'gtkmountoperation-stub.c',
]

def options(opt):
    pass

def configure(conf):
    if conf.is_defined('YTK'):
        autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB', atleast_version='2.28', mandatory=True)
        autowaf.check_pkg(conf, 'pango', uselib_store='PANGO', atleast_version='1.20', mandatory=True)
        autowaf.check_pkg(conf, 'cairo', uselib_store='CAIRO', atleast_version='1.12', mandatory=True)
        autowaf.check_pkg(conf, 'pangocairo', uselib_store='PANGOCAIRO', mandatory=True)
        autowaf.check_pkg(conf, 'gmodule-2.0', uselib_store='GMODULE', mandatory=True)
        if conf.env['build_target'] != 'mingw' and sys.platform != 'darwin': # Linux
            autowaf.check_pkg(conf, 'x11', uselib_store='X11', system=True, mandatory=True)
            autowaf.check_pkg(conf, 'xext', uselib_store='XEXT', system=True, mandatory=True)

def build(bld):
    if not bld.is_defined('YTK'):
        return

    obj = bld.shlib(features = 'c cshlib')
    obj.cflags          = [ bld.env['compiler_flags_dict']['pic'], '-w' ]
    obj.export_includes = ['ytk']
    obj.includes        = ['.', '..', 'ytk', 'ytk/gtk']
    obj.name            = 'libytk'
    obj.target          = 'ytk'
    obj.use             = [ 'libztk', 'libydk-pixbuf', 'libydk' ]
    obj.uselib          = 'GLIB GIO PANGO CAIRO PANGOCAIRO GMODULE'
    obj.defines         = [ 'HAVE_CONFIG_H', '_LARGEFILE64_SOURCE', '_REENTRANT', 'G_LOG_DOMAIN="Gtk"', 'GTK_COMPILATION', '_FILE_OFFSET_BITS=64', 'GTK_DISABLE_DEPRECATED', 'G_DISABLE_CAST_CHECKS',
                            'G_DISABLE_SINGLE_INCLUDES', 'DATK_DISABLE_SINGLE_INCLUDES', 'GDK_PIXBUF_DISABLE_SINGLE_INCLUDES', 'GTK_DISABLE_SINGLE_INCLUDES', 'GDK_PIXBUF_DISABLE_DEPRECATED',
                            'GTK_PRINT_BACKENDS="file,lpr"', 'GTK_PRINT_BACKEND_ENABLE_UNSUPPORTED', 'GTK_PRINT_PREVIEW_COMMAND=""',
                            'GTK_VERSION="2.24.23"', 'GTK_BINARY_VERSION="2.10.0"', 'GTK_HOST="ardour"',
                            'PACKAGE="' + I18N_PACKAGE + '"',
                            'GETTEXT_PACKAGE="' + I18N_PACKAGE + '"',
                            'GTK_DATA_PREFIX="' + bld.env['PREFIX'] + '"', 
                            'GTK_SYSCONFDIR="' + bld.env['SYSCONFDIR'] + '"', 
                            'GTK_DATA_DIR="' + bld.env['DATADIR'] + '"', 
                            'GTK_LIBDIR="' + bld.env['LIBDIR'] + '"',
                          ]
    obj.vnum            = LIBYDK_VERSION
    obj.install_path    = bld.env['LIBDIR']

    if sys.platform == 'darwin':
        obj.source   = libytk_sources +  libytk_quartz_sources
        obj.cflags   += ['-xobjective-c']
        obj.uselib   += ' OSX' #  -framework Cocoa -framework CoreFoundation -framework ApplicationServices
    elif bld.env['build_target'] == 'mingw':
        obj.source   = libytk_sources +  libytk_win32_sources
        obj.defines += [ 'INSIDE_GTK_WIN32', 'DLL_EXPORT', 'PIC' ]
        obj.ldflags  = '-limm32 -lole32 -lgdi32 -lcomdlg32 -lwinspool -lcomctl32 -luuid'
        obj.linkflags = ['-Wl,--export-all-symbols']
    else:
        obj.source    = libytk_sources +  libytk_x11_sources
        obj.uselib   += ' X11 XEXT'

    # i18n
    if bld.is_defined('ENABLE_NLS'):
        mo_files = bld.path.ant_glob('po/*.mo')
        for mo in mo_files:
            lang = os.path.basename(mo.srcpath()).replace('.mo', '')
            bld.install_as(os.path.join(bld.env['LOCALEDIR'], lang, 'LC_MESSAGES', I18N_PACKAGE + bld.env['MAJOR'] + '.mo'),
                           mo)
def i18n(bld):
    autowaf.build_i18n(bld, '.', 'libs/tk/ytk', I18N_PACKAGE + bld.env['MAJOR'], libytk_sources)

def i18n_pot(bld):
    autowaf.build_i18n(bld, '.', 'libs/tk/ytk', I18N_PACKAGE + bld.env['MAJOR'], libytk_sources)

def i18n_po(bld):
    autowaf.build_i18n_po(bld, '.', 'libs/tk/ytk', I18N_PACKAGE + bld.env['MAJOR'], libytk_sources)

def i18n_mo(bld):
    autowaf.build_i18n_mo(bld, '.', 'libs/tk/ytk', I18N_PACKAGE + bld.env['MAJOR'], libytk_sources)

=== debian/changelog ===
ardour (1:8.6.0+ds-1) unstable; urgency=medium

  * New upstream version 8.6.0+ds
    + Refresh patches
    + Drop patches applied upstream
  * Update copyright information
    + Bump copyright dates
    + Re-generate d/copyright_hints
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 23 Apr 2024 18:10:42 +0200

ardour (1:8.4.0+ds1-3) unstable; urgency=medium

  [ Erich Eickmeyer ]
  * Fix build with Python 3.12

  [ IOhannes m zmölnig ]
  * Fix dylib dependencies for ardour-lv2-plugins
  * Drop 'new_aaf_session'
    + Remove the now non-existant source fom d/copyright
    + Stop generating a manpage
  * Fix more spelling mistakes

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 08 Apr 2024 12:29:36 +0200

=== debian/control ===
Source: ardour
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Dennis Braun <d_braun@kabelmail.de>,
Build-Depends:
 debhelper-compat (= 13),
 dh-buildinfo,
 gettext,
 intltool,
 itstool,
# TODO: get rid of vendoring
 ladspa-sdk,
 libarchive-dev,
 libasound2-dev [linux-any],
 libaubio-dev,
 libboost-dev,
 libcairomm-1.0-dev,
 libcurl4-gnutls-dev,
 libcwiid-dev [linux-any],
 libdbus-1-dev,
 libfftw3-dev,
 libfluidsynth-dev,
 libglibmm-2.4-dev,
 libhidapi-dev,
 libjack-dev,
 liblilv-dev,
 liblo-dev,
 liblrdf0-dev,
 libltc-dev,
 libpangomm-1.4-dev,
 libpulse-dev,
 libqm-dsp-dev,
 libreadline-dev,
 librubberband-dev,
 libsamplerate0-dev,
 libsigc++-2.0-dev,
 libsndfile1-dev,
# TODO: get rid of vendoring
 libsuil-dev,
 libtag1-dev,
 libusb-1.0-0-dev,
 libwebsockets-dev,
 libxinerama-dev,
 libxrandr-dev,
 lv2-dev,
 python3,
 vamp-plugin-sdk,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://ardour.org
Vcs-Git: https://salsa.debian.org/multimedia-team/ardour.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ardour

Package: ardour
Architecture: any
Depends:
 ardour-data (<< ${source:Upstream-Version}.0~),
 ardour-data (>= ${source:Version}),
 ardour-lv2-plugins (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ardour-video-timeline,
Suggests:
 ${shlibs:Suggests},
Replaces:
 ardour3 (<< 1:3.5),
Breaks:
 ardour3 (<< 1:3.5),
Description: the digital audio workstation
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 Ardour supports pro-audio interfaces
 through the ALSA project, which provides high quality, well designed
 device drivers and API's for audio I/O under Linux. Any interface
 supported by ALSA can be used with Ardour. This includes the
 all-digital 26 channel RME Hammerfall, the Midiman Delta 1010 and many
 others.
 .
 Ardour has support for 24 bit samples
 using floating point internally, non-linear editing with unlimited undo,
 a user-configurable mixer, MTC master/slave capabilities, MIDI hardware
 control surface compatibility.
 .
 It supports MIDI
 Machine Control, and so can be controlled from any MMC controller and
 many modern digital mixers.
 .
 Ardour contains a
 powerful multitrack audio editor/arranger that is completely
 non-destructive and capable of all standard non-linear editing
 operations (insert, replace, delete, move, trim, select,
 cut/copy/paste). The editor has unlimited undo/redo capabilities and can
 save independent "versions" of a track or an entire piece
 .
 Ardour's editor supports the community-developed LADSPA
 plugin standard.  Arbitrary chains of plugins can be attached to any
 portion of a track.  Every mixer strip can have any number of inputs
 and outputs, not just mono, stereo or 5.1.  An N-way panner is
 included, with support for various panning models.  Pre- and post-fader
 sends exist, each with their own gain and pan controls.  Every mixer
 strip acts as its own bus, and thus the bus count in Ardour is
 unlimited.  You can submix any number of strips into another
 strip.
 .
 Ardour's channel capacity is limited only
 by the number on your audio interface and the ability of your disk
 subsystem to stream the data back and forth.
 .
 JACK
 (the JACK Audio Connection Kit) is used for all audio I/O, permitting
 data to be exchanged in perfect samplesync with other applications
 and/or hardware audio interfaces.
 .
 Ardour is
 sample rate and size neutral - any hardware formats from 8 to 32 bits,
 and rates from 8kHz to 192kHz.  Internal processing in 32/64 bit IEEE
 floating point format.
 .
 Further information can be
 found at <https://ardour.org/>.

Package: ardour-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 ardour,
Breaks:
 ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Replaces:
 ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Description: digital audio workstation (data)
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This package contains the architecture-independent data files.

Package: ardour-video-timeline
Architecture: all
Multi-Arch: foreign
Depends:
 ffmpeg (>= 7:1.2),
 harvid (>= 0.7.0),
 xjadeo (>= 0.6.4),
 ${misc:Depends},
Description: digital audio workstation - video timeline
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This is a dependency package to add video timeline capabilities to ardour.

Package: ardour-lv2-plugins
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lv2-plugin,
Description: digital audio workstation - lv2 plugins set
 Ardour is providing a set of LV2 plugins:
  * a-comp.lv2
    - a compressor (mono & stereo versions)
  * a-exp.lv2
    - an expander (mono & stereo versions)
  * a-delay.lv2
    - a delay (mono version)
  * a-eq.lv2
    - an equaliser (mono version)
  * a-reverb.lv2
    - a reverberation (stereo version)
  * a-fluidsynth.lv2
    - a SF2 player (stereo version)
  * reasonablesynth.lv2
    - a reasonably good piano synth (stereo version)
 .
 This package allows these to be used by other hosts as well.

=== debian/rules ===
#!/usr/bin/make -f
#
# Robert Jordens <jordens@debian.org>
# © 2019, IOhannes m zmölnig <umlaeute@debian.org>
# © 2020, Olivier Humbert <trebmuh@tuxfamily.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk
BUILD_DATE:=$(shell date -u -d "@$(SOURCE_DATE_EPOCH)" +"%F")

# Ardour uses some c++11 features requiring atomic_load_8 and
# probably more, so we need to link with libatomic on
# armel, powerpc, powerpcspe, m68k, mips, mipsel, sh4, ...
# see also:
# - https://gcc.gnu.org/wiki/Atomic
# - https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
# - packaging for 'clasp', 'juce',...
# link with libatomic on architectures without built-in atomic
ifneq ($(strip $(filter $(DEB_HOST_ARCH), armel powerpc powerpcspe m68k mips mipsel sh4 riscv64)),)
        LDFLAGS += -latomic
endif

ifeq ($(DEB_HOST_ARCH), mips64el)
        CXXFLAGS += -mxgot
endif

ifneq (,$(filter $(DEB_HOST_ARCH), mipsel sh4))
        CXXFLAGS += -g1
endif

########### WAF options ############
waf-light = python3 $(CURDIR)/debian/waf/waf-light
waf-configure-options = \
	--freedesktop \
	--configdir=/etc/ \
	--noconfirm \
	--prefix=/usr/ \
	--libjack=weak \
	--no-phone-home \
	--use-external-libs \
	--optimize \
	--cxx11 \
	--ptformat \
	--lv2dir=/usr/lib/lv2 \
	$(empty)


DIST_TARGET = none
ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	DIST_TARGET = i686
endif
ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	DIST_TARGET = x86_64
endif

BACKENDS = jack,dummy
ifneq (,$(findstring linux,$(DEB_HOST_ARCH_OS)))
# ALSA Backend is only available on Linux
	BACKENDS = jack,alsa,dummy,pulseaudio
else
	waf-configure-options += \
		--no-fpu-optimization \
		$(empty)
endif

ARDOUR_LIBRARY_PATH := /usr/lib/ardour8/

waf-configure-options += \
	--with-backends=$(BACKENDS) \
	--dist-target=$(DIST_TARGET) \
	$(empty)

DEB_WAF_INVOKE = \
	CPPFLAGS="$(CPPFLAGS)" \
	CFLAGS="$(CFLAGS)" \
	CXXFLAGS="$(CXXFLAGS)" \
	LDFLAGS="$(LDFLAGS) -Wl,--as-needed" \
	$(waf-light) -v --destdir=$(CURDIR)/debian/tmp

deb_revision := libs/ardour/revision.cc
waf_extras := debian/waf/waflib/extras/autowaf.py debian/waf/waflib/extras/misc.py

########### build overrides options ############
%:
	dh $@

execute_before_dh_auto_build:
	@echo "blhc: ignore-line-regexp: ^\[[ 0-9]+/[ 0-9]+\] Compiling .*"

override_dh_auto_build: genfiles
	$(DEB_WAF_INVOKE) configure $(waf-configure-options)
	$(DEB_WAF_INVOKE) build i18n_mo

override_dh_auto_install: override_dh_auto_build manpages genfiles
	$(DEB_WAF_INVOKE) install
	for res in 16 22 32 48; do \
		mkdir -p $(CURDIR)/debian/ardour/usr/share/icons/hicolor/$${res}x$${res}/mimetypes; \
		cp $(CURDIR)/gtk2_ardour/icons/application-x-ardour_$${res}px.png \
			$(CURDIR)/debian/ardour/usr/share/icons/hicolor/$${res}x$${res}/mimetypes/application-x-ardour.png ; \
	done

## ardour includes a couple of private lib*.so files, which make
## dh_makeshlibs emit a useless call to `ldconfig` in the postinst script.
## since we don't have any public libraries, we just suppress that call.
override_dh_makeshlibs:
	dh_makeshlibs --no-scripts
override_dh_shlibdeps:
	dh_shlibdeps -- -l$(CURDIR)/debian/ardour/$(ARDOUR_LIBRARY_PATH)

execute_before_dh_clean: manpageclean
	find . -name "*.pyc" -delete || true
	find . -name "*.mo" -delete || true

########### build intermediates ############
.PHONY: genfiles
genfiles: $(deb_revision) $(waf_extras)

$(deb_revision):
	echo '#include "ardour/revision.h"' > $@
	echo "namespace ARDOUR { const char* revision = \"$(subst +,~,$(DEB_VERSION_UPSTREAM_REVISION))\"; const char* date = \"$(BUILD_DATE)\"; }" >> $@

debian/waf/waflib/extras/%: tools/%
	cp $< $@

MANPAGES = ardour8-copy-mixer.1 \
	ardour8-export.1 \
	ardour8-new_empty_session.1 \
	ardour8-new_session.1 \
	ardour8-lua.1 \
	$(empty)
.PHONY: manpages manpageclean
$(MANPAGES): debian/ardour-utils.1
	cp $^ $@
manpages: $(MANPAGES)
manpageclean:
	rm -f $(MANPAGES)

################ d/copyright helper ##############
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|.*\.ico|.*\.icns|.*\.png|.*\.xcf|.*\.wav|.*\.flac|.*\.ogg|.*\.touchosc|.*\.tosc|.*\.pdf|.*\.woff
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

## ardour 8.9.0+ds

=== libs/hidapi/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import re
import sys

HIDAPI_VERSION = '0.8.0'

def options(opt):
    pass

def configure(conf):
    if conf.is_defined('USE_EXTERNAL_LIBS'):
        autowaf.check_pkg(conf, 'hidapi-hidraw', uselib_store='HIDAPI', mandatory=False)
    else:
        if conf.env['build_target'] == 'mingw':
            conf.check (compiler='cxx', lib='setupapi', mandatory=True, uselib_store='SETUPAPI')
            conf.define ('HAVE_HIDAPI', 1)
        elif sys.platform == 'darwin':
            conf.define ('HAVE_HIDAPI', 1)
        elif re.search ("linux", sys.platform) != None:
            autowaf.check_pkg(conf, 'libudev', uselib_store='UDEV', mandatory=False)
            if conf.is_defined('HAVE_UDEV'):
                conf.define ('HAVE_HIDAPI', 1)
        else:
            print ("hidapi is not yet available for the given system")

def build(bld):
    if bld.is_defined('USE_EXTERNAL_LIBS'):
        return
    if not bld.is_defined('HAVE_HIDAPI'):
        return

    # Host Library
    obj = bld(features = 'c cstlib')
    autowaf.ensure_visible_symbols (obj, False)
    obj.export_includes    = ['hidapi']
    obj.includes           = ['hidapi']
    obj.name               = 'hidapi'
    obj.target             = 'hidapi'
    obj.vnum               = HIDAPI_VERSION
    obj.install_path       = bld.env['LIBDIR']
    obj.defines            = '_POSIX_C_SOURCE=200809L'

    if bld.env['build_target'] == 'mingw':
        obj.source         = 'windows/hid.c'
        obj.linkflags      = [ '-lsetupapi', '-mwindows' ]
        obj.uselib         = 'SETUPAPI'
    else:
        obj.cflags        += [ bld.env['compiler_flags_dict']['pic'] ]
        if sys.platform == 'darwin':
            obj.source     = 'mac/hid.c'
            obj.framework  = [ 'IOKit', 'CoreFoundation' ]
        else:
            # with '-strict' this needs "-std=gnu99" to compile w/o warnings
            obj.source     = 'linux/hid.c'
            if re.search ("linux", sys.platform) != None:
                obj.uselib = 'UDEV'

=== debian/changelog ===
ardour (1:8.9.0+ds-1) unstable; urgency=medium

  * New upstream version 8.9.0+ds
    + Refresh patches
  * Remove the line from d/changelog (version 1:8.7.0+ds0-1) that
    erroneously claimed that the (not so) obsolete JACK1 patch was dropped
  * Update copyright information
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 19 Oct 2024 16:23:21 +0200

ardour (1:8.7.0+ds0-1) unstable; urgency=medium

  [ IOhannes m zmölnig (Debian/GNU) ]
  * New upstream version 8.7.0+ds
    + Refresh patches
  * Exclude vendored 'doxygen-awesome-css' files
  * Update copyright information
    + Update d/copyright
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 03 Oct 2024 23:16:01 +0200

## ardour 8.10.0%2Bds

=== debian/changelog ===
ardour (1:8.10.0+ds-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 01 Dec 2024 07:39:04 -0800

ardour (1:8.10.0+ds-1) unstable; urgency=medium

  * New upstream version 8.10.0+ds
    + Refresh patches
  * Use shlex.quote() rather than the deprecated pipes.quote()
    (Closes: #1084642)
  * Fix more spelling mistakes
  * Update copyright information
    + Drop non-existing files from d/copyright
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 05 Nov 2024 00:14:58 +0100

=== debian/rules ===
--- 
+++ 
@@ -117,6 +117,10 @@
 	find . -name "*.pyc" -delete || true
 	find . -name "*.mo" -delete || true
 
+# No dbgsym packages:
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
+
 ########### build intermediates ############
 .PHONY: genfiles
 genfiles: $(deb_revision) $(waf_extras)
